package newCynic;

import robocode.*;

import java.util.Iterator;
import java.util.Random;
import java.util.Vector;

/**
 *  .
 */

public class Cynical extends AdvancedRobot {
/*
    .
*/
    /**    */
    public static final double PRECISION = 1e-06;
    /** 2*Pi */
    public static final double DOUBLE_PI = Math.PI * 2;
    /** Pi/2 */
    public static final double HALF_PI = Math.PI/ 2;
    /**    . */
    public static final double MAX_GUN_ROTATION_SPEED = Math.toRadians(20);
    /**   . */
    public static final double MAX_SPEED = 8;
    /**   . */
    public static final double MAX_FIRE_POWER = 3;
    /**   . */
    public static final double BASE_FIRE_POWER = MAX_FIRE_POWER / 2.0;
    /**     . */
    public static final double FIRE_DELAY_CRITICAL = 400;
    /**   . */
    public static final double ENERGY_NORMAL_THRESHOLD = 50;
    /**   . */
    public static final double ENERGY_WARNING_THRESHOLD = 30;
    /**    . */
    public static final double ENERGY_CRITICAL_THRESHOLD = 15;
/*
     .
*/
    /**   */
    public double _battleFieldWidth, _battleFieldHeight;
    /**   */
    public double _robotSize;
    /**    */
    public double _robotSizeHalved;
    /**    */
    public double _collisionDelta;
    /**    .*/
    public int _aliveRobotsCount;
    /**   . */
    public long _currentTime;
    /**   . */
    public Random _randomizer = new Random();
    /**   . */
    public double _currentEnegy;
    /**   .*/
    public long _lastShotTime;
    /**  .*/
    public long _hits;
    /**  .*/
    public long _misses;
    /**    .*/
    public long _hittesByBullet;
    /**    .*/
    public long _wallCollisions;
    /**   */
    private Radar _radar;
    /**   */
    private Driver _driver;
    /**   */
    private Gunner _gunner;
    /**   */
    private TargetList _targets;
    /**   */
    public Vector _events;
    /**  - */
    private SupervisorState _currentState;
    /**   . */
    public SupervisorState getCurrentState() {
        return _currentState;
    }
    /**   . */
    public void setCurrentState(SupervisorState aCurrentState) {
        _currentState = aCurrentState;
    }
    /** ,     . */
    public void run() {
        //   A0   " ".
        SupervisorState.processIncomingEvent(Constants.EVENT_ROUND_START, this);

        while (true) {
            _currentTime = getTime();
            Logger.log("--------- " + _currentTime + " ---------");

            check_events();      //   .
            SupervisorState.processIncomingEvent(Constants.EVENT_STEP_START, this);              //   A0   " ".
            getGunner().beginTurn(); //   " "  "".
            getRadar().beginTurn();  //   " "  "".
            getDriver().beginTurn(); //   " "  "".
            endTurnEvent();          //   " ".
        }
    }

    /**     Robocode. */
    public void onBulletHit(BulletHitEvent first_e) {
        _events.add(first_e);
    }
    /**     Robocode. */

    public void onBulletMissed(BulletMissedEvent first_e) {
        _events.add(first_e);
    }
    /**     Robocode. */

    public void onBulletHitBullet(BulletHitBulletEvent first_e) {
        _events.add(first_e);
    }
    /**     Robocode. */

    public void onScannedRobot(ScannedRobotEvent first_e) {
        _events.add(first_e);
    }
    /**     Robocode. */

    public void onRobotDeath(RobotDeathEvent first_e) {
        _events.add(first_e);
    }
    /**     Robocode. */

    public void onHitRobot(HitRobotEvent first_e) {
        _events.add(first_e);
    }
    /**     Robocode. */

    public void onHitWall(HitWallEvent first_e) {
        _events.add(first_e);
    }
    /**     Robocode. */

    public void onHitByBullet(HitByBulletEvent first_e) {
        _events.add(first_e);
    }
    /**     Robocode. */

    public void onWin(WinEvent first_e) {
        SupervisorState.processIncomingEvent(Constants.EVENT_WIN, this);
    }
    /**     Robocode. */

    public void onDeath(DeathEvent first_e) {
        SupervisorState.processIncomingEvent(Constants.EVENT_DEATH, this);
    }

    /** ,  -logger      . */
    public Cynical() {
        Logger._out = out;
        SupervisorState.reset(this);
    }
/*
      .
*/
    /** z10_0 :   . */
    protected void z10_0_initializeAtStart() {
        if (Constants.OUTPUTS_LOGGING)
            Logger.logOutput("z10_0", "  ");
        setUpPriorities();
        setUpParameters();
        createDevices();
        _events = new Vector();
    }

    /**    -- , , ,  .*/
    private void createDevices() {
        setTargets(new TargetList(this));
        setRadar(new Radar(this));
        setDriver(new Driver(this));
        setGunner(new Gunner(this));
    }

    /**     . */
    private void setUpParameters() {
        _battleFieldWidth = getBattleFieldWidth();
        _battleFieldHeight = getBattleFieldHeight();
        _robotSize = (getWidth() + getHeight()) / 2.0;
        _robotSizeHalved = _robotSize / 2.0;
        _collisionDelta = _robotSizeHalved - 5;
        _hits = 0;
        _misses = 0;
        _hittesByBullet = 0;
        _wallCollisions = 0;
    }

    /**   .*/
    private void setUpPriorities() {
        setEventPriority("RobotDeathEvent", 17);
        setEventPriority("ScannedRobotEvent", 16);
        setEventPriority("HitRobotEvent", 15);
        setEventPriority("HitWallEvent", 14);
        setEventPriority("BulletHitEvent", 13);
        setEventPriority("HitByBulletEvent", 12);
        setEventPriority("BulletMissedEvent", 11);
    }

    /** z10_1 :    */
    protected void z10_1_initializeAtNewRound() {
        if (Constants.OUTPUTS_LOGGING)
            Logger.logOutput("z10_1", "   ");
        Logger.log("***");
        Logger.log("***  " + (getRoundNum() + 1));
        Logger.log("***");
        clearAllEvents();

        setAdjustGunForRobotTurn(true);
        setAdjustRadarForGunTurn(true);
        _currentTime = 0;
        getTargets().beginRound();
        getDriver().beginRound();
        getRadar().beginRound();
        getGunner().beginRound();

        if (_events != null) _events.clear();
    }

    /** z10_2 :    . */
    protected void z10_2_requestInputParametersAtNewStep() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z10_2", "   ");
        }
        _aliveRobotsCount = getOthers();
        _currentEnegy = getEnergy();

        getTargets().beginTurn();
    }

    /** z20 :     */
    protected void z20_printRoundStatistics() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z20", "  ");
        }
        showStatistics();
    }
/*
     .
*/
    /**     . */
    private void check_events() {
        Iterator eventIterator = _events.iterator();
        Event event;

        while (eventIterator.hasNext()) {
            event = (Event) eventIterator.next();

            if (event instanceof ScannedRobotEvent) {
                getTargets().update((ScannedRobotEvent) event);
            } else if (event instanceof BulletHitEvent) {
                getTargets().hit((BulletHitEvent) event);
                _hits++;
            } else if (event instanceof RobotDeathEvent) {
                getTargets().targetDestroyed((RobotDeathEvent) event);
            } else if (event instanceof HitRobotEvent) {
                DriverState.processIncomingEvent(Constants.EVENT_ENEMY_COLLISION, getDriver());
                getTargets().collision((HitRobotEvent) event);
            } else if (event instanceof HitWallEvent) {
                DriverState.processIncomingEvent(Constants.EVENT_WALL_COLLISION, getDriver());
                _wallCollisions++;
            } else if (event instanceof BulletMissedEvent) {
                _misses++;
            } else if (event instanceof HitByBulletEvent) {
                DriverState.processIncomingEvent(Constants.EVENT_HIT_BY_BULLET, getDriver());
                getTargets().hitByBullet((HitByBulletEvent) event);
                _hittesByBullet++;
            }
        }

        _events.clear();
    }

    /**  . */
    private void endTurnEvent() {
        getDriver().endTurn(); //   " "  "".
        getRadar().endTurn();  //   " "  "".
        getGunner().endTurn(); //   " "  "".
    }

    /**     */
    private void showStatistics() {
        long shots = _hits + _misses;

        getTargets().showStatistics();
        Logger.log(": " + shots + ", : " + _hits + ", : " + _misses);
        Logger.log(": " + (double) _hits / shots);
        Logger.log("  : " + _hittesByBullet);
        Logger.log("  : " + _wallCollisions);
    }

    /**     . */
    public static double  getBulletSpeed(double firepower) {
        return (20 - 3 * firepower);
    }

    /**      0  2PI. */
    public static double normalizeAngle(double a) {
        a = DOUBLE_PI + (a % DOUBLE_PI);
        a %= DOUBLE_PI;
        return a;
    }

    /**    
          . */
    public static double getAngleDiff(double from, double to) {
        double diff = to - from;

        if (Math.abs(diff) <= Math.PI) return diff;

        if (diff < 0)
            diff += DOUBLE_PI;
        else if (diff > 0)
            diff -= DOUBLE_PI;

        return diff % DOUBLE_PI;
    }

    /**   . */
    public static double getAngle(double x, double y) {
        double a;

        if (y == 0) {
            return x > 0 ? HALF_PI : 3 * HALF_PI;
        }

        a = Math.atan(x / y);

        if (y < 0) a += Math.PI;

        return a;
    }

    /**    .*/
    public Radar getRadar() {
        return _radar;
    }

    /**     .*/
    private void setRadar(Radar aRadar) {
        _radar = aRadar;
    }

    /**     .*/
    public Driver getDriver() {
        return _driver;
    }

    /**     .*/
    private void setDriver(Driver aDriver) {
        _driver = aDriver;
    }

    /**     .*/
    public Gunner getGunner() {
        return _gunner;
    }

    /**     .*/
    private void setGunner(Gunner aGunner) {
        _gunner = aGunner;
    }

    /**      .*/
    public TargetList getTargets() {
        return _targets;
    }

    /**      .*/
    private void setTargets(TargetList aTargets) {
        _targets = aTargets;
    }

    public static void main(String[] args) {
        new Cynical().run();
    }

}

