package newCynic;

/**
 *  .
 */

public class Driver {
/*
    .
*/
    /**  ""  . */
    private final double WALLS_COEFF = 100;
    /**  . */
    private final double HEADING_DELTA = Math.toRadians(30);
/*
     .
*/
    /**    _t110. */
    private long _t110;
    /**  .*/
    private double _oldHeading, _curHeading;
    /** .*/
    private double _oldX, _oldY, _curX, _curY;
    /**   . */
    private double _turningSpeed;
    /**  . */
    private double _curSpeed;
    /**        .*/
    private double _da;
    /**        . */
    private double _speed;
    /**  . */
    private GeomVector _direction = new GeomVector();
    /**  */
    private DriverState _currentState;
    /** - */
    Cynical _robot;

    /**
     *   .
     * @return ,   
     */
    public DriverState getCurrentState() {
        return _currentState;
    }

    /**
     *   
     * @param aCurrentState  
     */
    public void setCurrentState(DriverState aCurrentState) {
        _currentState = aCurrentState;
    }

    /**
     *   ""   -.
     * @param aRobot 
     */
    public Driver(Cynical aRobot) {
        _robot = aRobot;
        DriverState.reset(this);
    }

    /** ,     .   */
    public void beginRound() {
        _oldHeading = _robot.getHeadingRadians();
        _curHeading = _robot.getHeadingRadians();
        _curSpeed = 0;
        _oldX = _curX = _robot.getX();
        _oldY = _curY = _robot.getY();
        _turningSpeed = 0;
        _t110 = 0;
        _direction.reset();
        _da = 0;
        _speed = Cynical.MAX_SPEED;
    }

    /** ,         */
    public void beginTurn() {
        _oldHeading = _curHeading;
        _curHeading = _robot.getHeadingRadians();
        _oldX = _curX;
        _curX = _robot.getX();
        _oldY = _curY;
        _curY = _robot.getY();
        _curSpeed = Math.sqrt(Math.pow(_curX - _oldX, 2) + Math.pow(_curY - _oldY, 2));
        _curSpeed = _curSpeed * (_speed >= 0 ? 1 : -1);
        _turningSpeed = _robot.getAngleDiff(_oldHeading, _curHeading);
        _da = 0;
        DriverState.processIncomingEvent(Constants.EVENT_STEP_START, this);
    }

    /** ,    .    */
    public void endTurn() {
        _robot.setTurnRightRadians(_da);
        _robot.setAhead(_speed * 100);
    }

    /**
     *   .
     * @return  
     */
    public double getTurningSpeed() {
        return _turningSpeed;
    }
/*
      .
*/
    /** x100 :       */
    public boolean x100_enemyIsNear() {
        boolean result = true;
        if (_robot.getTargets()._closestTarget != null) {
            result = _robot.getTargets()._closestTarget._distance < 300;
        }
        if (Constants.INPUTS_LOGGING) {
            Logger.logInput("x100", " ", result);
        }
        return result;
    }

    /** x105 :      */
    public boolean x105_wallIsNear() {
        double collision_delta = _robot._robotSizeHalved + 40;
        boolean result =
                _curX < 0 + collision_delta
                || _curX > _robot._battleFieldWidth - collision_delta
                || _curY < 0 + collision_delta
                || _curY > _robot._battleFieldHeight - collision_delta;

        if (Constants.INPUTS_LOGGING) {
            Logger.logInput("x105", " ", result);
        }
        return result;
    }

    /** x110 :     T110 */
    public boolean x110_timeoutExpired() {
        boolean result = _robot._currentTime >= _t110;
        if (Constants.INPUTS_LOGGING) {
            Logger.logInput("x110", "  T110", result);
        }
        return result;
    }
/*
      
*/
    /** z200_0 :     ''. */
    public void z200_0_initializePendulumTrajectory() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z200_0", "    ''");
        }
        _robot.setMaxVelocity(10);
        getDirection();
    }

    /** z200_1 :      '' */

    public void z200_1_randomizePendulumTrajectory() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z200_1", "     ''");
        }
        _direction.setCoords(_direction.getAngle(), 1);
        double angle_diff = _robot.normalizeAngle(_direction.getAngle() +
                (_robot._randomizer.nextBoolean() ? Cynical.HALF_PI : -Cynical.HALF_PI));
        _direction.addRadialVector(angle_diff, 0.4);
    }

    /** z200_2 :       '' */
    public void z200_2_calculatePendulumTrajectory() {
        if (Constants.OUTPUTS_LOGGING)
            Logger.logOutput("z200_2", "     ''");

        calculate_movement_order(true);
    }

    /** z210_0 :     '' */
    public void z210_0_initializeArcTrajectory() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z210_0", "    ''");
        }
        double TTT = _robot.getTargets()._closestTarget != null
                ? _robot.getTargets()._closestTarget._distance / 20.0 : 10;

        TTT = TTT * (_robot._randomizer.nextDouble() * 0.5 + 0.8);
        _t110 = _robot._currentTime + Math.round(TTT);

        getDirection();
        _robot.setMaxVelocity(10);

        if (_robot.getTargets()._closestTarget != null) {
            double delta1 =
                    Math.abs(_robot.getAngleDiff(_direction.getAngle(), _robot.getTargets()._closestTarget._angle));
            double delta2 =
                    Math.abs(_robot.getAngleDiff(_direction.getAngle(),
                            _robot.normalizeAngle(_robot.getTargets()._closestTarget._angle + Math.PI)));
            if (delta1 > HEADING_DELTA || delta2 > HEADING_DELTA) {
                _direction.setAngle(_robot.normalizeAngle(_robot.getTargets()._closestTarget._angle + Math.PI
                        + (_robot._randomizer.nextBoolean() ? Cynical.HALF_PI / 2 : -Cynical.HALF_PI / 2)));
            }
        }
    }

    /** z210_1 :      '' */
    public void z210_1_randomizeArcTrajectory() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z210_1", "     ''");
        }
    }

    /** z210_2 :      '' */
    public void z210_2_calculateArcTrajectory() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z210_2", "     ''");
        }
        calculate_movement_order(false);
        _da = 0;
    }

    /** z220_0 :     ''  */
    public void z220_0_initializeDigressionTrajectory() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z220_0", "    ''");
        }
        _t110 = _robot._currentTime + 17;
        getDirection();
        _direction.setAngle(-Cynical.HALF_PI * (_direction.getAngle() / Math.abs(_direction.getAngle())));
        _robot.setMaxVelocity(5);
    }

    /** z220_1 :      '' */
    public void z220_1_randomizeDigressionTrajectory() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z220_1", "     ''");
        }
    }

    /** z220_2 :    '' */
    public void z220_2_calculateDigressionTrajectory() {
        if (Constants.OUTPUTS_LOGGING)
            Logger.logOutput("z220_2", "   ''");
        calculate_movement_order(false);
    }

    /** z230_0 :     '' */
    public void z230_0_initializeStopTrajectory() {
        if (Constants.OUTPUTS_LOGGING)
            Logger.logOutput("z230_0", "    ''");

        double TTT = _robot.getTargets()._closestTarget != null
                ? _robot.getTargets()._closestTarget._distance / 20.0 : 10;

        TTT = TTT * (_robot._randomizer.nextDouble() * 0.3 + 0.3);

        _t110 = _robot._currentTime + Math.round(TTT);
        _robot.setMaxVelocity(0);
    }

/*
     .
*/
    /**         . */
    private void getDirection() {
        _direction.reset();
        _direction.addCatresianVector(WALLS_COEFF / _curX, 0);
        _direction.addCatresianVector(-WALLS_COEFF / (_robot._battleFieldWidth - _curX), 0);
        _direction.addCatresianVector(0, WALLS_COEFF / _curY);
        _direction.addCatresianVector(0, -WALLS_COEFF / (_robot._battleFieldHeight - _curY));
        _direction.add(_robot.getTargets().getReactionVector());
    }

    /**    . */
    private void calculate_movement_order(boolean aReverseAllowed) {
        double da1,  // ,       .
                da2; // ,       .

        da1 = _robot.getAngleDiff(_curHeading, _direction.getAngle());
        da2 = _robot.getAngleDiff(_curHeading, _robot.normalizeAngle(_direction.getAngle() - Math.PI));

        if (aReverseAllowed) {
            if (Math.abs(da1) < Math.abs(da2)) {
                _da = da1;
                _speed = Cynical.MAX_SPEED;
            } else {
                _da = da2;
                _speed = -Cynical.MAX_SPEED;
            }
        } else {
            if (_speed > 0) {
                _da = da1;
            } else {
                _da = da2;
            }
        }
    }
}
