package newCynic;

/**
 *   " ".
 *    --  (, )
 */
public class GeomVector  {

    /**   .  */
    private double _angle;
    /**  . */
    private double _radius;
    /** ,    . */
    GeomVector() {
        this(0,0);
    }
    /** ,        . */
    GeomVector(double aAngle, double aRadius) {
        setCoords(aAngle, aRadius);
    }

    /**  . */
    public void reset() {
        setCoords(0, 0);
    }
    /**  . */
    public void setCoords(double a1, double R1) {
        setAngle(a1);
        setRadius(R1);
    } ;

    /**  . */
    public void add(GeomVector vect2) {
        addCatresianVector(vect2.getX(), vect2.getY());
    }

    /**  ,     . */
    public void addCatresianVector(double aX, double aY) {
        double newX = getX() + aX;
        double newY = getY() + aY;

        setAngle(Cynical.normalizeAngle(Cynical.getAngle(newX, newY)));
        setRadius(Math.sqrt(newX * newX + newY * newY));
    }

    /**  ,     . */
    public void addRadialVector(double aAngle, double aRadius) {
        double newX = getX() + aRadius * Math.sin(aAngle);
        double newY = getY() + aRadius * Math.cos(aAngle);

        setAngle(Cynical.normalizeAngle(Cynical.getAngle(newX, newY)));
        setRadius(Math.sqrt(newX * newX + newY * newY));
    }
    /**    . */
    public double getAngle() {
        return _angle;
    }

    /**   . */
    public double getRadius() {
        return _radius;
    }

    /**  x- . */
    public double getX() {
        return _radius * Math.sin(_angle);
    }

    /**  y- . */
    public double getY() {
        return _radius * Math.cos(_angle);
    }

    /**   . */
    private void setRadius(double aR) {
        _radius = aR;
    }

    /**    . */
    public void setAngle(double aAngle) {
        _angle = aAngle;
    }
}
