package newCynic;

/**
 *       ""
 */
public abstract class GunnerState {
    /**  ,    */
    private String _name;

    /** ,  .
     *     . */
    protected GunnerState(String aName) {
        _name = aName;
    }

    /** ,   . */
    public String getName() {
        return _name;
    }

    /** ,  .   
     *        .
     */
    public abstract void processEvent(int aEvent, Gunner aGunMaster);

    /** ,       .  
     *         .
     */
    public abstract void onEnter(Gunner aGunMaster);

    /**  ,   
     *  (     ).
     */
    public static void reset(Gunner aGunMaster) {
        aGunMaster.setState(STATE_0);
    }

    /**
     *   ,  .
     */
    protected static void chageParentState(Gunner aGunMaster, GunnerState aNewState) {
        Logger.logStateChange(Constants.GUNNER_AUTOMATE_NAME, aNewState.getName(), aGunMaster.getState().getName());
        aGunMaster.setState(aNewState);
        aNewState.onEnter(aGunMaster);
    }

    /**  0  "" */
    private static GunnerState STATE_0 = new GunnerState_0();
    /**  1  "" */
    private static GunnerState STATE_1 = new GunnerState_1();
    /**  2  "" */
    private static GunnerState STATE_2 = new GunnerState_2();
    /**  3  "" */
    private static GunnerState STATE_3 = new GunnerState_3();

    /**
     *  ,    aEvent  aGunMaster.
     *     .
     */
    public static void processIncomingEvent(int aEvent, Gunner aGunMaster) {

        doStartLogging(aGunMaster, aEvent);
        aGunMaster.getState().processEvent(aEvent, aGunMaster);
        doEndLogging(aGunMaster);
    }

    /**
     *    --  .
     */
    private static void doEndLogging(Gunner aGunMaster) {
        if (Constants.A1_END_LOGGING)
            Logger.logEnd(Constants.GUNNER_AUTOMATE_NAME, aGunMaster.getState().getName());
    }

    /**
     *    --  .
     */
    private static void doStartLogging(Gunner aGunMaster, int aEvent) {
        if (Constants.OBJECTS_LOGGING)
            Logger.log("  '':");

        if (Constants.A1_BEGIN_LOGGING)
            Logger.logBegin(Constants.GUNNER_AUTOMATE_NAME, aGunMaster.getState().getName(), aEvent);
    }

    /** ,   0  "" */
    private static class GunnerState_0 extends GunnerState {

        public GunnerState_0() {
            super("State 0");
        }

        public void processEvent(int aEvent, Gunner aGunMaster) {
            if (aGunMaster.x25_targetIsCaptured()) {
                chageParentState(aGunMaster, STATE_3);
            } else {
                aGunMaster.z30_selectTarget();
                aGunMaster.z70_dropTargetPathHistory();
                aGunMaster.z50_1_calculateRoughForestallingAndTurnGun();
            }
        }

        public void onEnter(Gunner aGunMaster) {
            aGunMaster.z30_selectTarget();
            aGunMaster.z70_dropTargetPathHistory();
        }
    }

    /** ,   1  "" */
    private static class GunnerState_1 extends GunnerState {

        public GunnerState_1() {
            super("State 1");
        }

        public void processEvent(int aEvent, Gunner aGunMaster) {
            if (aGunMaster.x26_targetIsLost()) {
                aGunMaster.z80_dropCurrentTarget();
                chageParentState(aGunMaster, STATE_0);
            } else if (aGunMaster.x30_gunWillTurnWithinTwoSteps() && aGunMaster.x22_gunWillBeColdWithinTwoSteps()) {
                chageParentState(aGunMaster, STATE_2);
            } else {
                aGunMaster.z40_calculateFirePower();
                aGunMaster.z50_0_calculateFineForestallingAndTurnGun();
            }
        }

        public void onEnter(Gunner aGunMaster) {
            aGunMaster.z40_calculateFirePower();
            aGunMaster.z50_0_calculateFineForestallingAndTurnGun();
        }
    }

    /** ,   2  "" */
    private static class GunnerState_2 extends GunnerState {

        public GunnerState_2() {
            super("State 2");
        }

        public void processEvent(int aEvent, Gunner aGunMaster) {
            if (aGunMaster.x26_targetIsLost()) {
                aGunMaster.z80_dropCurrentTarget();
                chageParentState(aGunMaster, STATE_0);
            } else if (aGunMaster.x21_gunIsCold() && aGunMaster.x50_isPointingFine()) {
                aGunMaster.z60_makeShot();
                chageParentState(aGunMaster, STATE_0);
            } else if (!aGunMaster.x30_gunWillTurnWithinTwoSteps()) {
                chageParentState(aGunMaster, STATE_1);
            } else {
                aGunMaster.z40_calculateFirePower();
                aGunMaster.z50_0_calculateFineForestallingAndTurnGun();
            }
        }

        public void onEnter(Gunner aGunMaster) {
            aGunMaster.z40_calculateFirePower();
            aGunMaster.z50_0_calculateFineForestallingAndTurnGun();
        }
    }

    /** ,   3  "" */
    private static class GunnerState_3 extends GunnerState {

        public GunnerState_3() {
            super("State 3");
        }

        public void processEvent(int aEvent, Gunner aGunMaster) {
            if (aGunMaster.x26_targetIsLost()) {
                aGunMaster.z80_dropCurrentTarget();
                chageParentState(aGunMaster, STATE_0);
            } else if (aGunMaster.x20_gunIsExpectedToBeCold()) {
                chageParentState(aGunMaster, STATE_1);
            } else {
                aGunMaster.z50_1_calculateRoughForestallingAndTurnGun();
            }
        }

        public void onEnter(Gunner aGunMaster) {
            aGunMaster.z50_1_calculateRoughForestallingAndTurnGun();
        }
    }
}
